import logging
from logging import Formatter

from colorama import Fore, Style


class ColouredFormatter(Formatter):
    MAPPING = {
        logging.DEBUG: Fore.GREEN,
        logging.INFO: Style.RESET_ALL,
        logging.WARNING: Fore.YELLOW,
        logging.ERROR: Fore.RED,
        logging.CRITICAL: Fore.MAGENTA,
    }
    FORMAT = "[%(asctime)s] [%(levelname)-8s] {%(name)s} | %(message)s"

    def format(self, record):
        seq = self.MAPPING.get(record.levelno, Style.RESET_ALL)  # Default INFO
        log_fmt = f"{seq}{self.FORMAT}"
        formatter = Formatter(fmt=log_fmt, datefmt="%Y-%m-%d %H:%M:%S")
        return formatter.format(record)
